# -*- coding: utf-8 -*-
import requests
import logging
from myops.ss_virtual_create import SS_Virtual_command
import json
log = logging.getLogger(__name__)
import pdb

class Mp2shushu():
    def __init__(self, gameid, channel):
        self.mp_url = f"http://10.10.5.4:2333/api/open/promotion/co-list?channelid={channel}&gameid={gameid}"
        self.filename = "/data/git/ops_interface/myops/csv/2001_b_n.csv"

    def get_ad_list(self):
        r = requests.get(self.mp_url)
        if r.status_code == requests.codes.ok:
            return self.split_data(r.json())
        else:
            return None

    def split_data(self, data):
        log.info(f"2 {data['result']}")
        try:
            result = data['result']
            begin = "b_n,b_n_china"
            text = ""
            for key in result.keys():
                text += f"{key},{result[key]}\n"
            result_new = f"{begin}\n{text}"
        except Exception:
            log.error(f"split {data} failed!", exc_info=True)
            result_new = None
        return result_new

    def write2csv(self, data):
        with open(self.filename, 'w') as f:
            f.write(data)

    def upload2ss(self):
        ss = SS_Virtual_command()
        ss.upload_2001_b_n()


    def run(self):
        try:
            data = self.get_ad_list()
            self.write2csv(data)
            self.upload2ss()
        except Exception:
            log.error("mp2ss failed", exc_info=True)


def main():
    mp = Mp2shushu(2001, 6001)
    mp.run()


if __name__ == "__main__":
    main()
